require "studio_game/clumsy_player"
require_relative 'spec_helper'

module StudioGame
describe ClumsyPlayer do
  before do
    @player = ClumsyPlayer.new("klutz")
  end
  
  it "only gets half the point value for each treasure" do
    @player.points.should == 0

    hammer = Treasure.new(:hammer, 50)
    @player.found_treasure(hammer)
    @player.found_treasure(hammer)
    @player.found_treasure(hammer)

    @player.points.should == 75

    crowbar = Treasure.new(:crowbar, 400)
    @player.found_treasure(crowbar)
    
    @player.points.should == 275    
    
    yielded = []
    @player.each_treasure do |treasure|
      yielded << treasure
    end

    yielded.should == [Treasure.new(:hammer, 75), Treasure.new(:crowbar, 200)]    
  end

  context "with a w00t b00st" do
    before do
      @initial_health = 100
      @w00t_b00st = 5  
      @player = ClumsyPlayer.new("klutz", @initial_health, @w00t_b00st)
    end
  
    it "has a w00t b00st" do
      @player.w00t_b00st.should == 5
    end

    it "gets w00t b00st number of w00ts when w00ted" do
      @player.w00t

      @player.health.should == @initial_health + (15 * @w00t_b00st)
    end
  end

end
end
